/**
 * actionOperator - warmhole
 */
define('detail.modules.actionOperator.Warmhole', 
        ['jQuery', 'Class'], 
function($, Class) {


return Class({
    
    init: function(view, config) {
        this.onEvent = $.os.supportsTouch ? 'tap' : 'click';
        this.div = $('div.unit-d-wormhole', view);
        this.config = config;

        this._bindEvent();
    },

    _bindEvent: function(){
        var $warmholeList = $('div.warmhole-list', this.div),
            that = this;

        $('a.link-warmhole', this.div).on('click', function(e){
            e.preventDefault();
        });

        $('a.link-warmhole', this.div).on('tap', function(e){
            var elm = $(this);

            if (that.div.hasClass('warmhole-close')){
                that.div.removeClass('warmhole-close');
                that.div.addClass('warmhole-open');
                $warmholeList.addClass('scale');
            } else {
                that.div.removeClass('warmhole-open');
                that.div.addClass('warmhole-close');
                $warmholeList.removeClass('scale');
            }
        });
    }

});


});
