define('detail.modules.buttonZone.View', 
        ['jQuery', 'Class', 'detail.core.Event', 'detail.lib.pageDialog.PageDialog'], 
function($, Class, Event, PageDialog) {


return Class({
    
    init: function(view, config) {
        this.onEvent = $.os.supportsTouch ? 'tap' : 'click';
        this.div = view;
        this.config = config;

        this._initDescription();
        this._bindClickEvent();
        this._initWW();
    },

    _bindClickEvent: function(){
        var that = this;

        $('button.btn-description', this.div).on(this.onEvent, function(e){
            e.preventDefault();

            that.pageDialog.showDialog();
            that.openFlag = true;
        });

        Event.on('closeDescriptionDialog', function(){
            that.pageDialog.closeDialog();
            that.openFlag = false;
        });

        Event.on('back', function() {
            if (that.openFlag) {
                Event.trigger('closeDescriptionDialog');
                return false;
            }
        });
    },

    _initDescription: function(){
        this.pageDialog = new PageDialog({
            module: 'description',
            actionType: 'desc',
            zindex: 99
        });
    },

    _initWW: function(){
        var that = this;

        $('button.btn-aliww', this.div).on(this.onEvent, function(e){
            e.preventDefault();

            // Wing.navigator.wangwang.isLogin(that.config.visitorMembeId ,function(data){
            //     var = data.data.loginstatus;
            // });
        });
    }

});


});
