define('detail.modules.commendOffer.Module', ['exports'], function(exports) {
    exports.view = function(model) {
        
        model.recid = "1131";
        model.statScene = "36";
        model.perItem = 3;
        model.dmtrackPic = 'recommend1pic';
        model.dmtrackTitle = 'recommend1title';
        model.objectType = 'offer';
        model.count = 6;
        // model.pid = "12345";
        // model.pageId = 123456789;
        
        // 截取需要的offer数
        model.irecomData = model.result ? model.result.slice(0, model.count) : [];

        model.getMobileDetailUrl = function(offerId){
            // mock
            // offerId = '1284073000';

            return 'http://detail.m.1688.com/page/index.html?offerId=' + offerId + '#wing';
        };

        model.getOfferImageUrl = function(url, size){
            var imgSize = size || 100,
                imgUrl = '';

            if (!url) {
                if (imgSize < 151) {
                    if (imgSize < 101) {
                        imgUrl = 'http://img.china.alibaba.com/cms/upload/other/nopic-100.png';
                    } else {
                        imgUrl = 'http://img.china.alibaba.com/cms/upload/other/nopic-150.png';
                    }
                } else {
                    if (imgSize < 221) {
                        imgUrl = 'http://img.china.alibaba.com/cms/upload/other/nopic-220.png';
                    } else {
                        imgUrl = 'http://img.china.alibaba.com/cms/upload/other/nopic-310.png';
                    }
                }
            } else {
                if (imgSize < 151) {
                    if (imgSize < 101) {
                        imgUrl = url + '.summ.jpg';
                    } else {
                        imgUrl = url + '.search.jpg';
                    }
                } else {
                    if (imgSize < 221) {
                        imgUrl = url + '.220x220.jpg';
                    } else {
                        imgUrl = url + '.310x310.jpg';
                    }
                }
            }

            return imgUrl;
        };
        
        model.fitLength = function(s, len){
            s = unescapeHTML(s);
            if (lenB(s) > len) {
                s = cut(s, len - 3) + '...';
            }
            return escapeHTML(s);
        };

        function unescapeHTML(str){
            var div = document.createElement('div');

            div.innerHTML = str.replace(/<\/?[^>]+>/gi, '');
            return div.childNodes[0] ? div.childNodes[0].nodeValue : '';
        }

        function escapeHTML(str, attr){
            if (attr) {
                return str.replace(/[<"']/g, function(s){
                    switch (s) {
                    case '"':
                        return '&quot;';
                    case "'":
                        return '&#39;';
                    case '<':
                        return '&lt;';
                    case '&':
                        return '&amp;';
                    default:
                        return s;
                    }
                });
            } else {
                var div = document.createElement('div');
                div.appendChild(document.createTextNode(str));
                return div.innerHTML;
            }
        }

        function lenB(str){
            return str.replace(/[^\x00-\xff]/g, '**').length;
        }

        function cut(str, len, ext){
            var val = str, cl = 0;

            if (lenB(val) <= len) {
                return val;
            }
            for (var i = 0, j = val.length; i < j; i++) {
                var code = val.charCodeAt(i);
                if (code < 0 || code > 255) {
                    cl += 2;
                } else {
                    cl++;
                }
                if (cl > len) {
                    return val.substr(0, i == 0 ? i = 1 : i) + (ext || '');
                }
            }

            return '';
        }
    };
});
