define('detail.modules.demo.View', 
		['jQuery', 'Class', 'lofty.ui.Popup', 'lofty.util.Touchevents'], 
function($, Class, Popup, Touchevents) {


return Class({
	
	init: function(elm, config) {
        var onEvnet = $.os.supportsTouch ? 'tap' : 'click';
        var popup = new Popup({
            tpl:".fui-dialog-body",
            isModal:true,
            beforeOpen:function(popup){
                return true;
            },
            beforeClose:function(popup){
            },
            contentSuccess:function(popup){
                popup.prepend($('<button class="fui-btn3 btn">insertBtn</button>'));
            },
            buttons:[
                {
                    'event':onEvnet,//事件类型
                    'selector':'.fui-btn1',//要绑定事件的元素
                    'callback':function(paramObj){//事件的回调函数
                        alert(paramObj.name);
                        console.log(this);//这里的this指向的是当前的dialog
                    },
                    'paramObj':{//回调函数要传入的参数(封装成对象便于管理)
                        'name':'按钮1'
                    }
                },
                {
                    'event':onEvnet,
                    'selector':'.fui-btn2',
                    'callback':function(popup,paramObj){
                        alert(paramObj.name);
                    },
                    'paramObj':{
                        'name':'按钮2'
                    }
                },
                {
                    'event':onEvnet,
                    'selector':'.fui-btn3',
                    'callback':function(popup,paramObj){
                        alert(paramObj.name);
                    },
                    'paramObj':{
                        'name':'insertBtn'
                    }
                },
                {
                    'event':onEvnet,
                    'selector':'.d-close',
                    'callback':function(popup,paramObj){
                        this.hide();
                    }
                }
            ]
		});

		$(".show-dialog").on(onEvnet,function(){
			popup.show();
		});
	}

});


});
