define('detail.modules.purchasingList.Module', ['exports'], function(exports) {
    exports.view = function(model) {

        model.getSize80x80URL = function(url) {
            return url.replace('.jpg', '.80x80xz.jpg');
        };

        model.skuDiscountPrice = model.skuDiscountPrice ? model.skuDiscountPrice : model.skuPrice;
        model.discountPrice = model.discountPrice ? model.discountPrice : model.price;

        model.getPriceMin = function(){
            var priceMin, tempPrice;
            
            if (model.isCentralized === 'true' || model.isLimitedGroup === 'true'){
                priceMin = model.discountPrice;
            } else if (model.isSKUOffer === 'true' && model.isRangePriceSku === 'false'){
                // 规格sku
                priceMin = model.skuDiscountPrice.split('-')[0];
            } else {
                // 阶梯sku，普通阶梯，单价
                tempPrice = model.discountPriceRanges[model.discountPriceRanges.length - 1];
                priceMin = tempPrice.convertPrice ? tempPrice.convertPrice : tempPrice.price;
            }

            return priceMin;
        };

        model.getPriceMax = function(){
            var priceMax, tempPrice;
            
            if (model.isCentralized === 'true' || model.isLimitedGroup === 'true'){
                priceMax = model.discountPrice;
            } else if (model.isSKUOffer === 'true' && model.isRangePriceSku === 'false'){
                // 规格sku
                priceMax =  (model.skuDiscountPrice.split('-').length > 1) ? model.skuDiscountPrice.split('-')[1] : model.skuDiscountPrice.split('-')[0];
            } else {
                // 阶梯sku，普通阶梯，单价
                tempPrice = model.discountPriceRanges[0];
                priceMax = tempPrice.convertPrice ? tempPrice.convertPrice : tempPrice.price;
            }

            return priceMax;
        };

        model.getSkuProp = function(){
            return (model.skuProps.length > 1) ? model.skuProps[0].prop + '、' + model.skuProps[1].prop : model.skuProps[0].prop;
        };

    };
});
